## deepin-editor 6.5.39

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(VERSION "6.0.0" CACHE STRING "Application version")

project(deepin-editor
    VERSION ${VERSION}
    DESCRIPTION "Text editor for DDE"
    HOMEPAGE_URL "https://github.com/linuxdeepin/deepin-editor"
    LANGUAGES CXX C
)

#set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
# 引入翻译生成
include(translation-generate)

# Find Qt version
find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
message("   >>> Found Qt version: ${QT_VERSION_MAJOR}")
set(QT_DESIRED_VERSION ${QT_VERSION_MAJOR})

if (QT_VERSION_MAJOR MATCHES 6)
    set(DTK_VERSION_MAJOR 6)
    set(KF_VERSION_MAJOR 6)
else()
    set(DTK_VERSION_MAJOR "")
    set(KF_VERSION_MAJOR 5)
endif()
message("   >>> Build with DTK: ${DTK_VERSION_MAJOR}")

# 设置软件版本
include_directories(${PROJECT_BINARY_DIR})
configure_file(${PROJECT_SOURCE_DIR}/src/environments.h.in ${PROJECT_BINARY_DIR}/environments.h @ONLY)

# 玲珑路径配置
add_definitions(-DLINGLONG_PREFIX=\"${CMAKE_INSTALL_PREFIX}/\")
# 高亮文件路径配置
set(KF5_HIGHLIGHT_INSTALL_PATH ${CMAKE_INSTALL_PREFIX}/share/deepin-editor/org.kde.syntax-highlighing)
add_definitions(-DKF5_HIGHLIGHT_PATH=\"${KF5_HIGHLIGHT_INSTALL_PATH}\")

add_subdirectory(src)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_subdirectory(tests)
endif()

=== src/CMakeLists.txt ===
if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
endif ()

# Sources files
file(GLOB HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/*.h"  "encodes/*.h" "common/*.h" "controls/*.h" "editor/*.h"  "thememodule/*.h" "widgets/*.h" "basepub/*.h")
file(GLOB SRCS "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp" "encodes/*.cpp" "common/*.cpp" "controls/*.cpp" "editor/*.cpp"  "thememodule/*.cpp" "widgets/*.cpp" "basepub/*.c")

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/encodes)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/common)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/controls)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/editor)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/thememodule)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/widgets)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/basepub)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/dbus)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/lib/include)

# Find the library
find_package(PkgConfig REQUIRED)

set(qt_required_components Gui Widgets DBus Concurrent PrintSupport Svg Xml)
if (QT_DESIRED_VERSION MATCHES 6)
    list(APPEND qt_required_components Core5Compat)
endif()
find_package(Qt${QT_DESIRED_VERSION} REQUIRED COMPONENTS ${qt_required_components})
find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Widget Core)
find_package(KF${KF_VERSION_MAJOR}Codecs REQUIRED)
find_package(KF${KF_VERSION_MAJOR}SyntaxHighlighting REQUIRED)

set(LINK_LIBS
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::Xml
    Qt${QT_VERSION_MAJOR}::Svg
    Qt${QT_VERSION_MAJOR}::Concurrent
    Qt${QT_VERSION_MAJOR}::PrintSupport
    Qt${QT_VERSION_MAJOR}::DBus
    Dtk${DTK_VERSION_MAJOR}::Widget
    Dtk${DTK_VERSION_MAJOR}::Core
    KF${KF_VERSION_MAJOR}::Codecs
    KF${KF_VERSION_MAJOR}::SyntaxHighlighting
)

if (QT_DESIRED_VERSION MATCHES 6)
    list(APPEND LINK_LIBS Qt${QT_DESIRED_VERSION}::Core5Compat)
else()
    include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})
endif()

find_package(ICU COMPONENTS i18n uc REQUIRED)

pkg_check_modules(chardet REQUIRED chardet)
include_directories(${chardet_INCLUDE_DIRS})
link_directories(${chardet_LIBRARY_DIRS})

# Tell CMake to create the executable
add_executable(deepin-editor ${SRCS} deepin-editor.qrc)
target_link_libraries(deepin-editor
    ${LINK_LIBS}
    ${chardet_LIBRARY_DIRS}
    ICU::i18n
    ICU::uc
    -lm
    uchardet
    dl
    chardet
)


# translation files
TRANSLATION_GENERATE(QM_FILES ${CMAKE_SOURCE_DIR}/translations)
add_custom_target(${PROJECT_NAME}_qm_files DEPENDS ${QM_FILES})
add_dependencies(${PROJECT_NAME} ${PROJECT_NAME}_qm_files)

# Install translations
install(FILES ${QM_FILES} DESTINATION share/${PROJECT_NAME}/translations)

install(FILES ${APP_ICONPATH} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps/)
install(FILES ${CMAKE_SOURCE_DIR}/src/images/deepin-editor.svg DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps/)

#代码覆盖率开关
if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
endif()

# Install help manual
#if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "loongarch64")
#    install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/assets/loongarch64/deepin-editor DESTINATION /usr/share/deepin-manual/manual-assets/application/)
if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/assets/loongarch64/deepin-editor DESTINATION ${CMAKE_INSTALL_PREFIX}/share/deepin-manual/manual-assets/application/)
else()
    install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/assets/deepin-editor DESTINATION ${CMAKE_INSTALL_PREFIX}/share/deepin-manual/manual-assets/application/)
endif()

install(TARGETS deepin-editor DESTINATION bin/)
install(FILES ${CMAKE_SOURCE_DIR}/deepin-editor.desktop DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications/)
install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/themes DESTINATION ${CMAKE_INSTALL_PREFIX}/share/deepin-editor/)

# 安装 DConfig 配置文件，1040及以下的默认DTK环境不支持DConfig
set(DCONFIG_APPID org.deepin.editor)
file(GLOB DCONFIG_FILES "${CMAKE_SOURCE_DIR}/misc/configs/*.json")
if(DEFINED DSG_DATA_DIR)
    if (DTK_VERSION_MAJOR EQUAL "6")
        dtk_add_config_meta_files(APPID ${DCONFIG_APPID} FILES ${DCONFIG_FILES})
    else()
        dconfig_meta_files(APPID ${DCONFIG_APPID} FILES ${DCONFIG_FILES})
    endif()
    message("-- DConfig is supported by DTK")
else()
    install(FILES ${DCONFIG_FILES} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dsg/configs/${DCONFIG_APPID})
    message("-- DConfig is not supported by DTK")
endif()

# 添加KF5格式高亮配置文件，/usr/share/org.kde.syntax-highlighting/syntax/ 为所有用户可读取高亮配置的路径
install(DIRECTORY ${CMAKE_SOURCE_DIR}/misc/org.kde.syntax-highlighing/syntax
    DESTINATION ${KF5_HIGHLIGHT_INSTALL_PATH})

=== debian/changelog ===
deepin-editor (6.5.39) unstable; urgency=medium

  * i18n: Updates for project Deepin Text Editor (#391)

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 16 Oct 2025 19:37:27 +0800

deepin-editor (6.5.38) unstable; urgency=medium

  * chore: Update linglong base and runtime

 -- wangrong <wangrong@uniontech.com>  Wed, 17 Sep 2025 11:25:22 +0800

deepin-editor (6.5.37) unstable; urgency=medium

  * fix: Optimize mark removal logic in TextEdit and enhance file path handling in Window

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 04 Sep 2025 17:02:39 +0800

deepin-editor (6.5.36) unstable; urgency=medium

  * Update version to 6.5.36.

 -- Tian ShiLin <tianshilin@uniontech.com>  Wed, 27 Aug 2025 11:13:48 +0800

deepin-editor (6.5.35) unstable; urgency=medium

  * fix: Change elide mode in Tabbar to ElideRight

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Fri, 22 Aug 2025 09:57:38 +0800

=== debian/control ===
Source: deepin-editor
Section: editors
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders: Ma Aiguo <imaiguo@gmail.com>,
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 pkg-config,
 qt6-5compat-dev | hello,
 qt6-base-dev | qtbase5-dev,
 qt6-tools-dev-tools | qttools5-dev-tools,
 qt6-tools-dev | qttools5-dev,
 qt6-base-private-dev | qtbase5-private-dev,
 qt6-svg-dev | libqt5svg5-dev,
 libdtk6widget-dev | libdtkwidget-dev,
 libdtk6gui-dev | libdtkgui-dev,
 libdtk6core-dev | libdtkcore-dev,
 libdtk6declarative-dev | libdtkcore5-bin,
 libpolkit-qt6-1-dev | libpolkit-qt5-1-dev,
 libkf6syntaxhighlighting-dev | libkf5syntaxhighlighting-dev,
 libkf6codecs-dev | libkf5codecs-dev,
 libgtest-dev,
 libgmock-dev,
 libchardet-dev,
 libuchardet-dev (>= 0.0.6),
 libicu-dev
Rules-Requires-Root: no
Standards-Version: 4.5.1

Package: deepin-editor
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 dde-qt6integration | dde-qt5integration,
 libdtk6widget | libdtkwidget5 (>= 5.4.11),
 libuchardet0 (>= 0.0.6),
 libchardet1
Description: Text editor for DDE (Deepin Desktop Environment)
 Advanced text editor based on dtk.
 .
 This package is part of DDE (Deepin Desktop Environment).
Recommends: uos-reporter, deepin-event-log

## deepin-editor 6.5.42

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,25 @@
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/basepub)
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/dbus)
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/lib/include)
+
+# Configure settings.json based on installation prefix
+# 根据 CMAKE_INSTALL_PREFIX 设置主题默认路径
+if(CMAKE_INSTALL_PREFIX MATCHES "^/opt/apps")
+    # 玲珑环境：CMAKE_INSTALL_PREFIX = /opt/apps/org.deepin.editor/files/
+    set(THEME_DEFAULT_PATH "${CMAKE_INSTALL_PREFIX}/share/deepin-editor/themes/deepin.theme")
+    message(STATUS "Linglong build detected (PREFIX=${CMAKE_INSTALL_PREFIX}), theme default path: ${THEME_DEFAULT_PATH}")
+else()
+    # 普通环境：使用标准路径
+    set(THEME_DEFAULT_PATH "/usr/share/deepin-editor/themes/deepin.theme")
+    message(STATUS "Normal build (PREFIX=${CMAKE_INSTALL_PREFIX}), theme default path: ${THEME_DEFAULT_PATH}")
+endif()
+
+# 在构建时从模板生成 settings.json
+configure_file(
+    "${CMAKE_CURRENT_SOURCE_DIR}/resources/settings.json.in"
+    "${CMAKE_CURRENT_SOURCE_DIR}/resources/settings.json"
+    @ONLY
+)
 
 # Find the library
 find_package(PkgConfig REQUIRED)

=== debian/changelog ===
deepin-editor (6.5.42) unstable; urgency=medium

  * fix: Improve audio device detection for TTS and STT functionality with DDE control center consistency

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 20 Nov 2025 18:54:32 +0800

deepin-editor (6.5.41) unstable; urgency=medium

  * fix: Configure settings.json generation and theme path based on installation prefix

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 06 Nov 2025 11:24:46 +0800

deepin-editor (6.5.40) unstable; urgency=medium

  * fix bugs.

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 30 Oct 2025 19:21:51 +0800
